"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.regexp.split");

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es6.array.index-of");

require("core-js/modules/es6.date.to-json");

require("core-js/modules/es6.array.find");

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.promise");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.string.iterator");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.function.bind");

var _Route = _interopRequireDefault(require("./Route"));

var _Group = _interopRequireDefault(require("./Group"));

var _Store = _interopRequireDefault(require("./Store"));

var _url = require("url");

var _utils = require("./utils");

var _router = _interopRequireDefault(require("next/router"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * @description
 * Router is the public interface used to define
 * routes, groups and Link components.
 *
 * @singleton
 *
 * @class Router
 */
var Router =
/*#__PURE__*/
function () {
  function Router() {
    _classCallCheck(this, Router);

    this.getRequestHandler = this.getRequestHandler.bind(this);
    this.withExportPathMap = this.withExportPathMap.bind(this);
    this.setCtx = this.setCtx.bind(this);
    this.NextRouter = _router.default;

    this._initialize();
  }
  /**
   * @description
   * Creates a new route which resolves to a Next.js page component.
   * @function add
   * @param {string} route The route name.
   * @param {string} page The Next.js page component.
   * @return {Route}
   */

  /**
   * @description
   * Set the context of your page. Only needed when you want to do a static next export
   * @function setCtx
   * @param {Object} ctx
   * @returns {void}
   */


  _createClass(Router, [{
    key: "setCtx",
    value: function setCtx(ctx) {
      this.ctx = ctx;
    }
    /**
     * @description
     * Dynamicly create an exportPathMap config for static next exports based on your routes.js
     * @function withExportPathMap
     * @param {Object} config
     * @returns {Object}
     */

  }, {
    key: "withExportPathMap",
    value: function withExportPathMap(config) {
      var _this = this;

      return _objectSpread({}, config, {
        exportPathMap: function () {
          var _exportPathMap = _asyncToGenerator(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee3() {
            var pages;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    pages = {};
                    _context3.next = 3;
                    return Promise.all([_this.domain].concat(_toConsumableArray(_Store.default._domains)).map(
                    /*#__PURE__*/
                    function () {
                      var _ref = _asyncToGenerator(
                      /*#__PURE__*/
                      regeneratorRuntime.mark(function _callee2(domain) {
                        return regeneratorRuntime.wrap(function _callee2$(_context2) {
                          while (1) {
                            switch (_context2.prev = _context2.next) {
                              case 0:
                                _context2.next = 2;
                                return Promise.all(_this.list().map(
                                /*#__PURE__*/
                                function () {
                                  var _ref2 = _asyncToGenerator(
                                  /*#__PURE__*/
                                  regeneratorRuntime.mark(function _callee(route) {
                                    var exportParams, resolvedRoute;
                                    return regeneratorRuntime.wrap(function _callee$(_context) {
                                      while (1) {
                                        switch (_context.prev = _context.next) {
                                          case 0:
                                            if (!(route._keys.length && route._export)) {
                                              _context.next = 7;
                                              break;
                                            }

                                            _context.next = 3;
                                            return route._export(route);

                                          case 3:
                                            exportParams = _context.sent;
                                            exportParams.forEach(function (params) {
                                              var resolvedRoute = route.getNextLinkProps(params, {
                                                domain: domain,
                                                protocol: _this.protocol || 'http'
                                              }, true);
                                              pages[resolvedRoute.as.replace(/.*\:\/\//, '').replace('.', '_ext_')] = {
                                                page: resolvedRoute.href,
                                                query: params
                                              };
                                            });
                                            _context.next = 9;
                                            break;

                                          case 7:
                                            resolvedRoute = route.getNextLinkProps({}, {
                                              domain: domain,
                                              protocol: _this.protocol || 'http'
                                            }, true);
                                            pages[resolvedRoute.as.replace(/.*\:\/\//, '').replace('.', '_ext_')] = {
                                              page: resolvedRoute.href
                                            };

                                          case 9:
                                          case "end":
                                            return _context.stop();
                                        }
                                      }
                                    }, _callee);
                                  }));

                                  return function (_x2) {
                                    return _ref2.apply(this, arguments);
                                  };
                                }()));

                              case 2:
                              case "end":
                                return _context2.stop();
                            }
                          }
                        }, _callee2);
                      }));

                      return function (_x) {
                        return _ref.apply(this, arguments);
                      };
                    }()));

                  case 3:
                    return _context3.abrupt("return", pages);

                  case 4:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3);
          }));

          function exportPathMap() {
            return _exportPathMap.apply(this, arguments);
          }

          return exportPathMap;
        }()
      });
    }
    /**
     * @description
     * Creates a new route which resolves to a Next.js page component.
     * @function add
     * @param {string} route The route name.
     * @param {string} page The Next.js page component.
     * @return {Route}
     */

  }, {
    key: "add",
    value: function add(route, page) {
      var routeInstance = new _Route.default(this, route, page);

      _Store.default.add(routeInstance);

      return routeInstance;
    }
    /**
     * @description
     * Resolves and returns the route that matches given **url** and **host**
     *
     * **Note:** The first matching route will be used. So make
     * sure the generic routes are created after the
     * static routes.
     * @function match
     * @param {string} url Url string to find a match for.
     * @param {string} host Domain to find a match for.
     * @returns {Object}
     */

  }, {
    key: "match",
    value: function match(url, host) {
      var protocol = "".concat(this.protocol, "://");
      var parsedHost = (0, _url.parse)(protocol + host);
      var domain = parsedHost.hostname;
      var parsedUrl = (0, _url.parse)(url, true);
      var pathname = parsedUrl.pathname,
          query = parsedUrl.query;
      var resolvedUrl = {};
      /*
      * Find the first matching route.
      */

      var matchingRoute = _Store.default.list().find(function (route) {
        resolvedUrl = route.resolve(pathname, domain);
        return resolvedUrl;
      });
      /*
      * Return null when unable to find a route.
      */


      if (!matchingRoute) {
        return {};
      }

      return _objectSpread({}, matchingRoute.toJSON(), {
        port: parsedHost.port,
        parsedUrl: parsedUrl,
        pathname: pathname,
        query: _objectSpread({}, query, resolvedUrl.subdomains),
        data: matchingRoute.data,
        params: resolvedUrl.params,
        domain: domain
      });
    }
    /**
     * @description
     * Create a group of routes.
     * Also see [Group](https://github.com/samueljoos/next-avenues/blob/master/docs/group.md).
     *
     * @function group
     *
     * @param {Function} callback Callback which should only contain calls to [Router.add](https://github.com/samueljoos/next-avenues/blob/master/docs/router.md#routeraddroute-page).
     * @param {string} [name] Same as using [Route.as](https://github.com/samueljoos/next-avenues/blob/master/docs/group.md#asname).
     * @returns {Group}
     *
     * @example
     * routes.group(() => {
     *     routes.add('/', 'dashboard')
     *     // the route name will be admin.dashboard
     * }, 'admin')
     */

  }, {
    key: "group",
    value: function group(callback, name) {
      this._validateGroupClosure(callback);

      this._validateNestedGroups();

      _Store.default.breakpoint(name);

      callback();
      /*
      * Create a new group and pass all the routes
      * to the group.
      */

      var group = new _Group.default(_Store.default.breakpointRoutes());

      if (name) {
        group.as(name);
      }

      _Store.default.releaseBreakpoint();

      return group;
    }
    /**
     * @description
     * Returns an array of all the registered routes
     *
     * @function list
     *
     * @returns {Array}
     */

  }, {
    key: "list",
    value: function list() {
      return _Store.default.list();
    }
    /**
     * @description
     * Return the current active route.
     * This is usualy called inside the getInitialProps a Next.js page component.
     *
     * @function getCurrentRoute
     * @returns {Object}
     */

  }, {
    key: "getCurrentRoute",
    value: function getCurrentRoute() {
      var path = this.currentUrl || this.ctx && this.ctx.req && this.ctx.req.url || this.path || document.location.href;
      path = path.replace('_ext_', '.');
      var domain;

      if (typeof window !== 'undefined') {
        domain = document.location.host;
      } else {
        domain = this.currentHost || 'localhost:3000';
      }

      _Store.default._domains.forEach(function (d) {
        if (path.indexOf(d) === 0) {
          domain = d;
          path = path.replace(d, '');
        }
      });

      return this.match(path, domain);
    }
    /**
     * @description
     * Middleware function for your nextjs server setup.
     *
     * @function getRequestHandler
     * @param {Next.App} app The value of Next.js next().
     * @param {Function} [customHandler] Callback to customise the renderHandler parameters.
     *
     * @returns {Function}
     */

  }, {
    key: "getRequestHandler",
    value: function getRequestHandler(app, customHandler) {
      var _this2 = this;

      var nextHandler = app.getRequestHandler();
      return function (req, res) {
        var route = _this2.match(req.url, req.headers.host);

        _this2.currentUrl = req.url;
        _this2.currentHost = req.headers.host;
        _this2.port = route.port;
        _this2.domain = route.domain;
        _this2.protocol = req.headers.referer && req.headers.referer.split('://')[0] || 'http';

        if (route.pathname) {
          if (customHandler) {
            customHandler({
              req: req,
              res: res,
              route: route,
              query: route.query
            });
          } else {
            app.render(req, res, '/' + route.page, route.query);
          }
        } else {
          nextHandler(req, res, route.parsedUrl);
        }
      };
    }
    /**
     * @description
     * Push State helper for navigating to a route.
     * **note:** This doesn't work serverside.
     *
     * @param {string} name The route name.
     * @param {Object} [params] The route parameters.
     * @param {Object} [query] The route query parameters.
     *
     * @example
     * router.add('/post/:slug','blog-post').as('blog-post');
     * router.pushRoute('blog-post', {slug:'post-slug'}, {order:'1'});
     * // resolves to /post/post-slug?order=1
     */

  }, {
    key: "pushRoute",
    value: function pushRoute(name, params, query) {
      this._browserHistoryApply('push', name, params, query);
    }
    /**
     * @description
     * Replace State helper for navigating to a route.
     * **note:** This doesn't work serverside.
     *
     * @param {string} name The route name.
     * @param {Object} [params] The route parameters.
     * @param {Object} [query] The route query parameters.
     *
     * @example
     * router.add('/post/:slug','blog-post').as('blog-post');
     * router.replaceRoute('blog-post', {slug:'post-slug'}, {order:'1'});
     * // resolves to /post/post-slug?order=1
     */

  }, {
    key: "replaceRoute",
    value: function replaceRoute(name, params, query) {
      this._browserHistoryApply('replace', name, params, query);
    }
    /**
     * @description
     * Prefetch a route
     * **note:** This doesn't work serverside.
     *
     * @param {string} name The route name.
     * @param {Object} [params] The route parameters.
     * @param {Object} [query] The route query parameters.
     *
     * @example
     * router.add('/post/:slug','blog-post').as('blog-post');
     * router.prefetchRoute('blog-post', {slug:'post-slug'}, {order:'1'});
     * // prefetches the data for /post/post-slug?order=1
     */

  }, {
    key: "prefetchRoute",
    value: function prefetchRoute(name, params, query) {
      this._browserHistoryApply('prefetch', name, params, query);
    } //////
    // Private functions
    //////

    /**
     * @description
     * Initialize the client url location data
     *
     * @function _validateGroupClosure
     *
     * @returns {void}
     *
     * @private
     */

  }, {
    key: "_initialize",
    value: function _initialize() {
      var _this3 = this;

      if (typeof window !== 'undefined') {
        this.port = document.location.port;
        this.domain = document.location.host.split(':')[0];
        this.protocol = document.location.protocol.split(':')[0];
        this.NextRouter.events.on('routeChangeStart', function (url) {
          _this3.path = url;
        });
      }
    }
    /**
     * @description
     * Validates the group closure to make sure
     * it is a function
     *
     * @function _validateGroupClosure
     *
     * @param  {Function} callback
     *
     * @private
     */

  }, {
    key: "_validateGroupClosure",
    value: function _validateGroupClosure(callback) {
      if (typeof callback !== 'function') {
        throw (0, _utils.errorMessage)('Route.group expects a callback', callback);
      }
    }
    /**
     * @description
     * Validates that nested groups are not created.
     *
     * @function _validateNestedGroups
     *
     * @private
     */

  }, {
    key: "_validateNestedGroups",
    value: function _validateNestedGroups() {
      if (_Store.default.hasBreakpoint()) {
        _Store.default.releaseBreakpoint();

        throw (0, _utils.errorMessage)('Nested route groups are not allowed', 500, 'E_NESTED_ROUTE_GROUPS');
      }
    }
    /**
     * @description
     * Helper function for browser history methods.
     * Used by [router.pushRoute](https://github.com/samueljoos/next-avenues/blob/master/docs/router.md#pushroutenameparamsquery) [router.replaceRoute](https://github.com/samueljoos/next-avenues/blob/master/docs/router.md#replaceroutenameparamsquery) [router.prefetchRoute](https://github.com/samueljoos/next-avenues/blob/master/docs/router.md#prefetchroutenameparamsquery)
     *
     * @param {string} method Should be one of push, replace or prefetch.
     * @param {string} name The route name.
     * @param {Object} params The route Params.
     * @param {Object} query The route query.
     */

  }, {
    key: "_browserHistoryApply",
    value: function _browserHistoryApply(method, name, params, query) {
      if (typeof window === 'undefined') {
        throw (0, _utils.errorMessage)('Pushing routes is only available in the client', 'router.push');
      }

      var route = _Store.default.find(name, this.domain);

      var nextLinkProps = route.getNextLinkProps(params, {
        domain: this.domain,
        protocol: this.protocol,
        query: query
      });
      this.NextRouter[method](nextLinkProps.href, nextLinkProps.as);
    }
  }]);

  return Router;
}();

var _default = new Router();

exports.default = _default;